| Elektra 0.11.0

keyDel

- start = 2021-02-14 03:55
- end = 2021-02-14 04:25
- reviewer = Stefan Hanreich stefa.nosp@m.nhan.nosp@m.i@gma.nosp@m.il.c.nosp@m.om

# Signature

`int keyDel(Key *key)`

# Checklist

### Doxygen

(bullet points are in order of appearance)

- [x] First line explains briefly what the function does
- [ ] Simple example or snippet how to use the function
  - [ ] add example
- [x] Longer description of function containing common use cases
- [x] Description of functions reads nicely
- [ ] `@pre`
  - [x]
    Precondition
      Key must not be null
- [ ] `@post`
  - [x]
    Postcondition
      Key memory has been freed
- [ ] `@invariant <br>
  - [x] add (tbd)
  `
- `[x]`
  Parameters

    <tt>for | every parameter

- [ ]
  Returns
    `/`
  Return values

    <tt> |

  <br>
  - [ ]0`when the key was freed and no references are held in keysets`
- `[ ]`
  Since
    `<br>
    - [ ] add
    `
- `[x]`<>
- [x]
  See also
    `

## Naming

- [x] Abbreviations used in function names must be defined in the Glossary
- [x] Function names should neither be too long, nor too short
- [x] Function name should be clear and unambiguous
- [x] Abbreviations used in parameter names must be defined in the Glossary
- [x] Parameter names should neither be too long, nor too short
- [x] Parameter names should be clear and unambiguous

## Compatibility

(only in PRs)

- Symbol versioning is correct for breaking changes
- ABI/API changes are forward-compatible (breaking backwards-compatibility to add additional symbols is fine)

## Parameter & Return Types

- [x] Function parameters should use enum types instead of boolean types wherever sensible
- [x] Wherever possible, function parameters should be `const`
- [ ] Wherever possible, return types should be `const`
  - [ ] could maybe change this to const
- [x] Functions should have the least amount of parameters feasible

## Structural Clarity

- [x] Functions should do exactly one thing
- [x] Function name has the appropriate prefix
- [ ] Order of signatures in kdb.h.in is the same as Doxygen
  - [ ] swap keyClear and keyDel
- [x] No functions with similar purpose exist

## Memory Management

- [x] Memory Management should be handled by the function wherever possible

## Extensibility

- [x] Function is easily extensible, e.g., with flags
- [ ] Documentation does not impose limits, that would hinder further extensions
  - [ ] TBD cannot change behavior of referenced keys

## Tests

- [x] Function code is fully covered by tests
- [x] All possible error states are covered by tests
- All possible enum values are covered by tests
- [x] No inconsistencies between tests and documentation

# Summary

# Other Issues discovered (unrelated to function)